    View Javadoc
    1   package org.apache.bcel.classfile;
    2
    3   /* ====================================================================
    4    * The Apache Software License, Version 1.1
    5    *
    6    * Copyright (c) 2001 The Apache Software Foundation.  All rights
    7    * reserved.
    8    *
    9    * Redistribution and use in source and binary forms, with or without
    10   * modification, are permitted provided that the following conditions
    11   * are met:
    12   *
    13   * 1. Redistributions of source code must retain the above copyright
    14   *    notice, this list of conditions and the following disclaimer.
    15   *
    16   * 2. Redistributions in binary form must reproduce the above copyright
    17   *    notice, this list of conditions and the following disclaimer in
    18   *    the documentation and/or other materials provided with the
    19   *    distribution.
    20   *
    21   * 3. The end-user documentation included with the redistribution,
    22   *    if any, must include the following acknowledgment:
    23   *       "This product includes software developed by the
    24   *        Apache Software Foundation (http://www.apache.org/)."
    25   *    Alternately, this acknowledgment may appear in the software itself,
    26   *    if and wherever such third-party acknowledgments normally appear.
    27   *
    28   * 4. The names "Apache" and "Apache Software Foundation" and
    29   *    "Apache BCEL" must not be used to endorse or promote products
    30   *    derived from this software without prior written permission. For
    31   *    written permission, please contact apache@apache.org.
    32   *
    33   * 5. Products derived from this software may not be called "Apache",
    34   *    "Apache BCEL", nor may "Apache" appear in their name, without
    35   *    prior written permission of the Apache Software Foundation.
    36   *
    37   * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
    38   * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
    39   * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    40   * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
    41   * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    42   * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    43   * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
    44   * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    45   * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    46   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    47   * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    48   * SUCH DAMAGE.
    49   * ====================================================================
    50   *
    51   * This software consists of voluntary contributions made by many
    52   * individuals on behalf of the Apache Software Foundation.  For more
    53   * information on the Apache Software Foundation, please see
    54   * <http://www.apache.org/>;.
    55   */
    56
    57  import  org.apache.bcel.Constants;
    58  import  java.io.*;
    59
    60  /***
    61   * This class is derived from <em>Attribute</em> and represents a constant
    62   * value, i.e., a default value for initializing a class field.
    63   * This class is instantiated by the <em>Attribute.readAttribute()</em> method.
    64   *
    65   * @version $Id: ConstantValue.java,v 1.5 2003/02/13 11:18:23 enver Exp $
    66   * @author  <A HREF="mailto:markus.dahm@berlin.de">M. Dahm</A>
    67   * @see     Attribute
    68   */
    69  public final class ConstantValue extends Attribute {
    70    private int constantvalue_index;
    71
    72    /***
    73     * Initialize from another object. Note that both objects use the same
    74     * references (shallow copy). Use clone() for a physical copy.
    75     */
    76    public ConstantValue(ConstantValue c) {
    77      this(c.getNameIndex(), c.getLength(), c.getConstantValueIndex(),
    78  	 c.getConstantPool());
    79    }
    80
    81    /***
    82     * Construct object from file stream.
    83     * @param name_index Name index in constant pool
    84     * @param length Content length in bytes
    85     * @param file Input stream
    86     * @param constant_pool Array of constants
    87     * @throw IOException
    88     */
    89    ConstantValue(int name_index, int length, DataInputStream file,
    90  		ConstantPool constant_pool) throws IOException
    91    {
    92      this(name_index, length, (int)file.readUnsignedShort(), constant_pool);
    93    }
    94
    95    /***
    96     * @param name_index Name index in constant pool
    97     * @param length Content length in bytes
    98     * @param constantvalue_index Index in constant pool
    99     * @param constant_pool Array of constants
    100    */
    101   public ConstantValue(int name_index, int length,
    102 		       int constantvalue_index,
    103 		       ConstantPool constant_pool)
    104   {
    105     super(Constants.ATTR_CONSTANT_VALUE, name_index, length, constant_pool);
    106     this.constantvalue_index = constantvalue_index;
    107   }
    108
    109   /***
    110    * Called by objects that are traversing the nodes of the tree implicitely
    111    * defined by the contents of a Java class. I.e., the hierarchy of methods,
    112    * fields, attributes, etc. spawns a tree of objects.
    113    *
    114    * @param v Visitor object
    115    */
    116   public void accept(Visitor v) {
    117     v.visitConstantValue(this);
    118   }
    119   /***
    120    * Dump constant value attribute to file stream on binary format.
    121    *
    122    * @param file Output file stream
    123    * @throws IOException
    124    */
    125   public final void dump(DataOutputStream file) throws IOException
    126   {
    127     super.dump(file);
    128     file.writeShort(constantvalue_index);
    129   }
    130   /***
    131    * @return Index in constant pool of constant value.
    132    */
    133   public final int getConstantValueIndex() { return constantvalue_index; }
    134
    135   /***
    136    * @param constantvalue_index.
    137    */
    138   public final void setConstantValueIndex(int constantvalue_index) {
    139     this.constantvalue_index = constantvalue_index;
    140   }
    141
    142   /***
    143    * @return String representation of constant value.
    144    */
    145   public final String toString() {
    146     Constant c = constant_pool.getConstant(constantvalue_index);
    147
    148     String   buf;
    149     int    i;
    150
    151     // Print constant to string depending on its type
    152     switch(c.getTag()) {
    153     case Constants.CONSTANT_Long:    buf = "" + ((ConstantLong)c).getBytes();    break;
    154     case Constants.CONSTANT_Float:   buf = "" + ((ConstantFloat)c).getBytes();   break;
    155     case Constants.CONSTANT_Double:  buf = "" + ((ConstantDouble)c).getBytes();  break;
    156     case Constants.CONSTANT_Integer: buf = "" + ((ConstantInteger)c).getBytes(); break;
    157     case Constants.CONSTANT_String:
    158       i   = ((ConstantString)c).getStringIndex();
    159       c   = constant_pool.getConstant(i, Constants.CONSTANT_Utf8);
    160       buf = "\"" + Utility.convertString(((ConstantUtf8)c).getBytes()) + "\"";
    161       break;
    162
    163     default:
    164       throw new IllegalStateException("Type of ConstValue invalid: " + c);
    165     }
    166
    167     return buf;
    168   }
    169
    170   /***
    171    * @return deep copy of this attribute
    172    */
    173   public Attribute copy(ConstantPool constant_pool) {
    174     ConstantValue c = (ConstantValue)clone();
    175     c.constant_pool = constant_pool;
    176     return c;
    177   }
    178 }

This page was automatically generated by Maven